<?php

function pKCS7Padding($plaintext, $blockSize) {
    $padding = $blockSize - (strlen($plaintext) % $blockSize);
    $padtext = str_repeat(chr($padding), $padding);
    return $plaintext . $padtext;
}

function pKCS7Unpadding($plaintext, $blockSize) {
    $padding = ord($plaintext[strlen($plaintext) - 1]);
    if ($padding > $blockSize || $padding > strlen($plaintext)) {
        throw new Exception("Invalid padding");
    }
    return substr($plaintext, 0, strlen($plaintext) - $padding);
}

function CbcEncrypt($plaintext, $encodingAes) {
    $aeskey = base64_decode($encodingAes . "=");
    $blockSize = 32;
    $padMsg = pKCS7Padding($plaintext, $blockSize);

    $iv = substr($aeskey, 0, 16);
    $ciphertext = openssl_encrypt($padMsg, 'AES-256-CBC', $aeskey, OPENSSL_RAW_DATA, $iv);

    $base64Msg = base64_encode($ciphertext);
    return $base64Msg;
}

function CbcDecrypt($base64EncryptMsg, $encodingAes) {
    $aeskey = base64_decode($encodingAes . "=");
    $encryptMsg = base64_decode($base64EncryptMsg);

    $iv = substr($aeskey, 0, 16);
    $decrypted = openssl_decrypt($encryptMsg, 'AES-256-CBC', $aeskey, OPENSSL_RAW_DATA, $iv);

    $blockSize = 32;
    $plaintext = pKCS7Unpadding($decrypted, $blockSize);
    return $plaintext;
}

$plaintext = "1111";
$encodingAes = "0VShOOAlYzVbKvcU0JRfsEdArPPunB5B6CMoFdAYVXa";

$secretText = CbcEncrypt($plaintext, $encodingAes);
echo "密文：", $secretText, "\n";

$text = CbcDecrypt($secretText, $encodingAes);
echo "明文：", $text, "\n";