import base64
from Cryptodome.Cipher import AES
from Cryptodome.Util.Padding import pad, unpad

def pKCS7Padding(plaintext, block_size):
    padding = block_size - (len(plaintext) % block_size)
    padtext = bytes([padding]) * padding
    return plaintext + padtext

def pKCS7Unpadding(plaintext, block_size):
    padding_len = plaintext[-1]
    if padding_len > block_size or padding_len > len(plaintext):
        raise ValueError("Invalid padding")
    return plaintext[:-padding_len]

def CbcEncrypt(plaintext, encodingAes):
    aeskey = base64.b64decode(encodingAes + "=")
    block_size = 32
    padMsg = pad(plaintext.encode(), block_size)

    cipher = AES.new(aeskey, AES.MODE_CBC, aeskey[:AES.block_size])
    ciphertext = cipher.encrypt(padMsg)

    base64Msg = base64.b64encode(ciphertext)
    return base64Msg

def CbcDecrypt(base64EncryptMsg, encodingAes):
    aeskey = base64.b64decode(encodingAes + "=")
    encrypt_msg = base64.b64decode(base64EncryptMsg)

    block_size = 32
    cipher = AES.new(aeskey, AES.MODE_CBC, aeskey[:AES.block_size])
    decrypted = cipher.decrypt(encrypt_msg)

    plaintext = unpad(decrypted, block_size)
    return plaintext

plaintext = "1111"
encodingAes = "0VShOOAlYzVbKvcU0JRfsEdArPPunB5B6CMoFdAYVXa"

secretText = CbcEncrypt(plaintext, encodingAes)
print("密文：", secretText.decode())

text = CbcDecrypt(secretText, encodingAes)
print("明文：", text.decode())